// @ts-nocheck
import { Observable } from 'rxjs';
import { Subject } from 'rxjs';
import { Rest } from './rest.class';
import { RestHeaders } from './rest-headers';
import { Cookie } from './cookie';
import { Mapping } from './mapping';
import { Models } from './models';
import { Circ } from 'json10/browser';
export declare class Resource<E, T, TA> {
    protected static _listenErrors: Subject<Models.BackendError>;
    protected static _listenSuccess: Subject<Models.HttpResponse<any>>;
    static get listenErrors(): Observable<Models.BackendError>;
    static get listenSuccessOperations(): Observable<Models.HttpResponse<any>>;
    static enableWarnings: boolean;
    private getZone;
    static initAngularNgZone(zone: any): void;
    private checkNestedModels;
    private static instance;
    private static endpoints;
    static getModel(endpoint: string, model: string): Rest<any>;
    private static request;
    static create<A, TA = A[]>(e: string, model?: string, entityMapping?: Mapping.Mapping, circular?: Circ[], customContentType?: RestHeaders): Models.ResourceModel<A, TA>;
    static reset(): void;
    private constructor();
    static Cookies: Cookie;
    private static map;
    private static prepareModel;
    /**
     * And enipoint to application
     *
     * @param {E} endpoint
     * @param {string} model
     * @returns {boolean}
     */
    private add;
    /**
     * Access api throught endpoint
     *
     * @param {E} endpoint
     * @param {string} model
     * @returns {Rest<T, TA>}
     */
    private api;
}